with Interfaces.C.Strings; use Interfaces.C.Strings;
with Messages; use Messages;
with Sessions; use Sessions;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
package LocalQueues is
  type LocalQueue is tagged private;
  pragma CPP_Class(LocalQueue);

  procedure Get(Lq : LocalQueue; QueueName : Unbounded_String; Ses : Session;  Msg : Message; Time_Out : Integer);
  
  function Empty (Lq : LocalQueue) return Boolean;
  pragma Import (C_Plus_Plus, Empty, "_ZN11LocalQueueC5EmptyEv");

  function Size (Lq : LocalQueue) return Integer;
  pragma Import (C_Plus_Plus, Size, "_ZN11LocalQueueC4SizeEv");

  function New_LocalQueue return LocalQueue'class;
  pragma CPP_Constructor (New_LocalQueue);
  pragma Import(CPP, New_LocalQueue, "_ZN11LocalQueueCC2Ev");

  private
    type LocalQueue is tagged record
      null;
    end record;

end LocalQueues;
